Index: /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCell.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCell.h	(revision 2199)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCell.h	(revision 2332)
@@ -291,6 +291,14 @@
 	}
 
+	void SetEntriesInPvs(const int e) {
+		mEntriesInPvs = e;
+	}
+
 	float GetPvsCost() const {
 		return mPvsCost;
+	}
+
+	int GetEntriesInPvs() const {
+		return mEntriesInPvs;
 	}
 
@@ -324,8 +332,5 @@
 	/// store pvs size, used for evaluation purpose when pvss are stored only in the leaves
 	float mPvsCost;
-	/** stores number of entries in pvs
-	    this variable has the same value as mPvsSize for object pvs, 
-		but usually not for kd cell based pvs
-	*/
+	/// stores number of entries in pvs
 	int mEntriesInPvs;
 	/** if the pvs size scalar (+ entries into pvs)
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/VspTree.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/VspTree.cpp	(revision 2288)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/VspTree.cpp	(revision 2332)
@@ -59,64 +59,4 @@
 }
 
-#if WORK_WITH_VIEWCELLS
-static bool ViewCellHasMultipleReferences(Intersectable *obj, 
-										  ViewCell *vc, 
-										  bool checkOnlyMailed)
-{
-	MailablePvsData *vdata = obj->mViewCellPvs.Find(vc);
-
-	if (vdata)
-	{
-		// more than one view cell sees this object inside different kd cells
-		if (!checkOnlyMailed || !vdata->Mailed())
-		{
-			if (checkOnlyMailed)
-				vdata->Mail();
-			//Debug << "sumpdf: " << vdata->mSumPdf << endl;
-			if (vdata->mSumPdf > 1.5f) 
-				return true;
-		}
-	}
-	
-	return false;
-}
-
-
-void VspTree::RemoveParentViewCellReferences(ViewCell *parent) const
-{
-	KdLeaf::NewMail();
-
-	// remove the parents from the object pvss
-	ObjectPvsEntries::const_iterator oit, oit_end = parent->GetPvs().mEntries.end();
-
-	for (oit = parent->GetPvs().mEntries.begin(); oit != oit_end; ++ oit)
-	{
-		Intersectable *object = (*oit).first;
-		// HACK: make sure that the view cell is removed from the pvs
-		const float high_contri = 9999999;
-
-		// remove reference count of view cells
-		object->mViewCellPvs.RemoveSample(parent, high_contri);
-	}
-}
-
-
-void VspTree::AddViewCellReferences(ViewCell *vc) const
-{
-	KdLeaf::NewMail();
-
-	// Add front view cell to the object pvsss
-	ObjectPvsEntries::const_iterator oit, oit_end = vc->GetPvs().mEntries.end();
-
-	for (oit = vc->GetPvs().mEntries.begin(); oit != oit_end; ++ oit)
-	{
-		Intersectable *object = (*oit).first;
-
-		// increase reference count of view cells
-		object->mViewCellPvs.AddSample(vc, 1);
-	}
-}
-
-#endif
 
 void VspTreeStatistics::Print(ostream &app) const
@@ -185,7 +125,4 @@
 mTreeValid(true), 
 mTimeStamp(0)
-//,mRenderCostDecr(0)
-//,mMemoryIncr(0)
-//,mPvsEntriesIncr(0)
 {}
 
@@ -194,7 +131,4 @@
 mParent(parent), 
 mTreeValid(true), 
-//,mMemoryIncr(0)
-//,mRenderCostDecr(0)
-//,mPvsEntriesIncr(0)
 mTimeStamp(0)
 {}
@@ -602,5 +536,8 @@
 
 
-void VspTree::CreateViewCell(VspTraversalData &tData, const bool updatePvs)
+void VspTree::CreateViewCell(VspTraversalData &tData, 
+							 const bool updatePvs, 
+							 const float renderCost,
+							 const int pvs)
 {
 	///////////////
@@ -628,4 +565,11 @@
 		mVspStats.contributingSamples += conSamp;
 		mVspStats.sampleContributions += (int)sampCon;
+	}
+	else
+	{
+		// todo: set correct scalars
+		viewCell->SetPvsCost(renderCost);
+		viewCell->SetEntriesInPvs(pvs);
+		//cout << "create view cell with tri=" << (int)renderCost << " pvs=" << pvs << endl; 
 	}
 
@@ -802,5 +746,5 @@
 	VspLeaf *leaf = static_cast<VspLeaf *>(splitCandidate.mParentData.mNode);
 
-		//////////////
+	//////////////
 	//-- compute global decrease in render cost
 
@@ -810,5 +754,6 @@
 
 	float frontRenderCost = 0, backRenderCost = 0, totalRenderCost = 0;
-	int  frontSize = 0, backSize = 0, totalSize = 0;
+	float frontTriangles = 0, backTriangles = 0, totalTriangles = 0;
+	int  frontObjects = 0, backObjects = 0, totalObjects = 0;
 
 	Intersectable::NewMail(3);
@@ -827,4 +772,5 @@
 
 		VssRay *ray = rayInf.mRay;
+
 #if HACK_PERFORMANCE
 		Intersectable *obj = (*ray).mTerminationObject;
@@ -835,6 +781,6 @@
 		// and back pvs with respect to the classification
 		UpdateContributionsToPvs(leaf, cf, 
-								 frontRenderCost, backRenderCost, totalRenderCost,
-								 frontSize, backSize, totalSize);
+								 frontTriangles, backTriangles, totalTriangles,
+								 frontObjects, backObjects, totalObjects);
 
 #if COUNT_ORIGIN_OBJECTS
@@ -847,6 +793,6 @@
 
 			UpdateContributionsToPvs(leaf, cf, 
-									 frontRenderCost, backRenderCost, totalRenderCost,
-									 frontSize, backSize, totalSize);
+									 frontTriangles, backTriangles, totalTriangles,
+									 frontObjects, backObjects, totalObjects);
 		}
 #endif
@@ -857,8 +803,13 @@
 	}
 
+	totalRenderCost = mViewCellsManager->ComputeRenderCost((int)totalTriangles, totalObjects);
+	backRenderCost = mViewCellsManager->ComputeRenderCost((int)backTriangles, backObjects);
+	frontRenderCost = mViewCellsManager->ComputeRenderCost((int)frontTriangles, frontObjects);
+
+	
 	/////////////
 	// avg ray contri
 
-	const float avgRayContri = (float)totalSize / 
+	const float avgRayContri = (float)totalObjects / 
 		((float)splitCandidate.mParentData.mRays->size() + Limits::Small);
 
@@ -866,5 +817,5 @@
 
 	const float avgRaysPerObject = 
-		(float)splitCandidate.mParentData.mRays->size() / ((float)totalSize + Limits::Small);
+		(float)splitCandidate.mParentData.mRays->size() / ((float)totalTriangles + Limits::Small);
 
 	splitCandidate.SetAvgRayContribution(avgRayContri);
@@ -872,13 +823,22 @@
 
 
+	// todo: compute old render cost in the function
+	// using michi's render cost evaluation
 	float oldRenderCost;
-	const float renderCostDecr = EvalRenderCostDecrease(splitCandidate, oldRenderCost,
-														 totalRenderCost, frontRenderCost, backRenderCost);
+	const float renderCostDecr = EvalRenderCostDecrease(splitCandidate, 
+														oldRenderCost,
+														totalRenderCost, 
+														frontRenderCost, 
+														backRenderCost);
+
 	splitCandidate.SetRenderCostDecrease(renderCostDecr);
 
 	// the increase in pvs entries num induced by this split
-	const int pvsEntriesIncr = EvalPvsEntriesIncr(splitCandidate, totalSize, frontSize, backSize);
+	const int pvsEntriesIncr = EvalPvsEntriesIncr(splitCandidate, totalObjects, frontObjects, backObjects);
 	splitCandidate.SetPvsEntriesIncr(pvsEntriesIncr);
 
+	splitCandidate.mFrontTriangles = frontTriangles;
+	splitCandidate.mBackTriangles = backTriangles;
+	
 	// take render cost of node into account 
 	// otherwise danger of being stuck in a local minimum!
@@ -894,4 +854,5 @@
 	splitCandidate.SetPriority(priority);
 
+	//cout << "vsp render cost decrease=" << renderCostDecr<<endl;
 	mEvalTimer.Exit();
 }
@@ -958,6 +919,6 @@
 
 	//-- compute pvs
-	frontData.mPvs = sc.mFrontPvs;//(float)EvalPvsEntriesSize(*frontData.mRays);
-	backData.mPvs = sc.mBackPvs;//(float)EvalPvsEntriesSize(*backData.mRays);
+	frontData.mPvs = sc.mFrontPvs;
+	backData.mPvs = sc.mBackPvs;
 	
 	//-- compute pvs correction for coping with undersampling
@@ -975,6 +936,6 @@
 
 	//-- compute render cost
-	frontData.mRenderCost = sc.mFrontRenderCost;//(float)EvalPvsCost(*frontData.mRays);
-	backData.mRenderCost = sc.mBackRenderCost;//(float)EvalPvsCost(*backData.mRays);
+	frontData.mRenderCost = sc.mFrontRenderCost;
+	backData.mRenderCost = sc.mBackRenderCost;
 	
 	frontData.mCorrectedRenderCost = sc.mCorrectedFrontRenderCost;
@@ -1006,9 +967,4 @@
 		parent->ReplaceChildLink(leaf, interior);
 		interior->SetParent(parent);
-
-#if WORK_WITH_VIEWCELLS
-		// remove "parent" view cell from pvs of all objects (traverse through rays)
-		RemoveParentViewCellReferences(tData.mNode->GetViewCell());
-#endif
 	}
 	else // new root
@@ -1031,6 +987,6 @@
 
 	// create front and back view cell for the new leaves
-	CreateViewCell(frontData, false);
-	CreateViewCell(backData, false);
+	CreateViewCell(frontData, false, sc.mFrontTriangles, (int)sc.mFrontPvs);
+	CreateViewCell(backData, false, sc.mBackTriangles, (int)sc.mBackPvs);
 
 	// set the time stamp so the order of traversal can be reconstructed
@@ -1444,5 +1400,5 @@
 	
 	const int leaves = mVspStats.Leaves();
-	const bool showViz = (leaves % 30 == 0);
+	const bool showViz = (leaves >= 3000) && (leaves % 497 == 0);
 
 	if (showViz)
@@ -1685,8 +1641,7 @@
 	
 	const AxisAlignedPlane &candidatePlane = sc.mSplitPlane;
-	//const float avgRayContri = sc.GetAvgRayContribution();
 	const float avgRaysPerObject = sc.GetAvgRaysPerObject();
 
-	//////////////////////////////////////////////
+	/////////////////////////
 	// mark objects in the front / back / both using mailboxing
 	// then count pvs sizes
@@ -1713,5 +1668,4 @@
 
 	const float oldRenderCostRatio = (tData.mRenderCost > 0)? (totalPvs / tData.mRenderCost) : 1;
-
 	const float penaltyOld = tData.mCorrectedRenderCost * oldRenderCostRatio;
 
@@ -1731,19 +1685,4 @@
 	// the render cost decrase for this split
 	const float renderCostDecrease = (oldRenderCost - newRenderCost) / viewSpaceVol;
-
-	if (0)
-	cout << "vsp render cost"
-		 << " avg rays per object: " << avgRaysPerObject << " ratio: " << oldRenderCostRatio
-		 << " parent: " << penaltyOld << " " << " old vol: " << totalPvs 
-		 << " front cost: " << sc.mCorrectedFrontRenderCost << " corr. " << sc.mCorrectedFrontRenderCost
-		 << " back cost: " << sc.mCorrectedBackRenderCost << " corr. " << sc.mCorrectedBackRenderCost << endl;
-
-#ifdef GTP_DEBUG
-	Debug << "\nvsp render cost decrease" << endl
-		  << "back pvs: " << pvsBack << " front pvs " << pvsFront << " total pvs: " << totalPvs << endl 
-		  << "back p: " << pBack / viewSpaceVol << " front p " << pFront / viewSpaceVol << " p: " << pOverall / viewSpaceVol << endl
-		  << "old rc: " << normalizedOldRenderCost << " new rc: " << newRenderCost / viewSpaceVol << endl
-		  << "render cost decrease: " << renderCostDecrease << endl;
-#endif
 
 	return renderCostDecrease;
@@ -1809,10 +1748,8 @@
 	if (!obj) return;
 
-	const float renderCost = ViewCellsManager::EvalRenderCost(obj);
-
 	// object in none of the pvss => new object
 	if (!obj->Mailed() && !obj->Mailed(1) && !obj->Mailed(2))
 	{
-		totalPvs += renderCost;
+		totalPvs += 1.0f;
 	}
 
@@ -1824,5 +1761,5 @@
 		if (!obj->Mailed() && !obj->Mailed(2))
 		{
-			frontPvs += renderCost;
+			frontPvs += 1.0f;
 		
 			// already in back pvs => in both pvss
@@ -1838,5 +1775,5 @@
 		if (!obj->Mailed(1) && !obj->Mailed(2))
 		{
-			backPvs += renderCost;
+			backPvs += 1.0f;
 		
 			// already in front pvs => in both pvss
@@ -1860,5 +1797,5 @@
 
 	const float renderCost = countEntries ? 1 : 
-		mBvHierarchy->EvalAbsCost(leaf->mObjects);
+		(float)leaf->mObjects.size();
 	
 	// leaf in no pvs => new
@@ -1907,10 +1844,10 @@
 									   int &totalSize) const
 {
-	const float renderCost = mBvHierarchy->EvalAbsCost(leaf->mObjects);
-	
-	// leaf in no pvs => new
+	const float triSize = (float)leaf->mObjects.size();
+	
+	// object in no pvs => count as new
 	if (!leaf->Mailed() && !leaf->Mailed(1) && !leaf->Mailed(2))
 	{
-		totalPvs += renderCost;
+		totalPvs += triSize;
 		++ totalSize;
 	}
@@ -1920,5 +1857,5 @@
 		if (!leaf->Mailed() && !leaf->Mailed(2))
 		{
-			frontPvs += renderCost;
+			frontPvs += triSize;
 			++ frontSize;
 
@@ -1935,5 +1872,5 @@
 		if (!leaf->Mailed(1) && !leaf->Mailed(2))
 		{
-			backPvs += renderCost;
+			backPvs += triSize;
 			++ backSize;
 
@@ -2569,5 +2506,6 @@
 					// cases N1,N2,N3,P5,Z2,Z3
 					continue;
-				} else
+				} 
+				else
 				{
 					// case N4
@@ -2639,4 +2577,219 @@
 	return hits;
 }
+
+
+#ifdef USE_SSE
+int VspTree::TraverseRayPacket(RayPacket &rp,
+							   const bool useMailboxing)
+{
+	int hits = 0;
+
+	// reciprocal of ray directions
+	float one = 1.0f;
+	float zero = 0.0f;
+
+	__m128 one4 = _mm_load_ps(&one);
+	__m128 zero4 = _mm_load_ps(&zero);
+
+	__m128 *entp4;
+	__m128 *extp4;
+
+	union { float mask[4]; __m128 mask4; };
+	mask4 = one4;
+
+	__m128 entpX4 = rp.mOriginX4;
+	__m128 entpY4 = rp.mOriginY4;
+	__m128 entpZ4 = rp.mOriginZ4;
+	
+	__m128 extpX4 = rp.mTerminationX4;
+	__m128 extpY4 = rp.mTerminationY4;
+	__m128 extpZ4 = rp.mTerminationZ4;
+
+	__m128 *origin = &rp.mOriginX4;
+	__m128 *termination = &rp.mTerminationX4;
+
+	// ray directions
+	__m128 dirX4 = _mm_sub_ps(rp.mTerminationX4, rp.mOriginX4);
+	__m128 dirY4 = _mm_sub_ps(rp.mTerminationY4, rp.mOriginY4);;
+	__m128 dirZ4 = _mm_sub_ps(rp.mTerminationZ4, rp.mOriginZ4);;
+	
+	__m128 rdx4 = _mm_div_ps(one4, dirX4);
+	__m128 rdy4 = _mm_div_ps(one4, dirY4);
+	__m128 rdz4 = _mm_div_ps(one4, dirZ4);
+
+	__m128 maxT4 = one4;
+	__m128 minT4 = zero4;
+
+	stack<PacketTraversalData *> tStack;
+
+
+	VspNode *node = mRoot;
+	VspNode *farChild;
+
+	float position;
+	int axis;
+
+	__m128 position4;
+
+	while (1)
+	{
+		if (!node->IsLeaf())
+		{
+			VspInterior *in = static_cast<VspInterior *>(node);
+			
+			entp4 = &entpX4;
+			extp4 = &extpX4;
+
+			position = in->GetPosition();
+			axis = in->GetAxis();
+
+			position4 = _mm_load_ps(&position);
+
+			// are the entry points all in near leaf?
+			if (_mm_movemask_ps(_mm_and_ps(_mm_cmple_ps(entp4[axis], position4), mask4)))
+			{
+				// are the exit points all in near leaf?
+				if (_mm_movemask_ps(_mm_and_ps(_mm_cmpgt_ps(extp4[axis], position4), mask4)))
+				{
+					node = in->GetBack();
+					// cases N1,N2,N3,P5,Z2,Z3
+					continue;
+				} 
+				else // traverse both children
+				{
+					// case N4
+					node = in->GetBack();
+					farChild = in->GetFront();
+				}
+			}
+			else
+			{
+				if (_mm_movemask_ps(_mm_and_ps(_mm_cmpgt_ps(position4, extp4[axis]), mask4)))
+				{
+					node = in->GetFront();
+					// cases P1,P2,P3,N5,Z1
+					continue;
+				}
+				else // traverse both children
+				{
+					node = in->GetFront();
+					farChild = in->GetBack();
+					// case P4
+				}
+			}
+
+ 			// $$ modification 3.5.2004 - hints from Kamil Ghais
+			// case N4 or P4
+			const __m128 tDist4 = _mm_mul_ps(_mm_sub_ps(position4, origin[axis]), termination[axis]);
+			
+			// push far child for further processing
+			tStack.push(new PacketTraversalData(farChild, extpX4, extpY4, extpZ4, maxT4, mask4));
+
+			// compute new exit point
+			extpX4 = _mm_add_ps(_mm_mul_ps(dirX4, tDist4), rp.mOriginX4);
+			extpY4 = _mm_add_ps(_mm_mul_ps(dirY4, tDist4), rp.mOriginY4);
+			extpZ4 = _mm_add_ps(_mm_mul_ps(dirZ4, tDist4), rp.mOriginZ4);
+
+			maxT4 = tDist4;
+
+			mask4 = _mm_cmplt_ps( maxT4, minT4);
+		}
+		else
+		{
+			// compute intersection with all objects in this leaf
+			VspLeaf *leaf = static_cast<VspLeaf *>(node);
+			ViewCell *viewCell;
+
+			viewCell = leaf->GetViewCell();
+
+			// note: don't have to mail if each view 
+			// cell belongs to exactly one leaf
+			if (!useMailboxing || !viewCell->Mailed())
+			{
+				if (useMailboxing)
+					viewCell->Mail();
+
+				for (int i = 0; i < 4; ++i)
+				{
+					if (mask[i]) 
+						rp.mViewCells[i].push_back(viewCell);
+				}
+
+				++ hits;
+			}
+
+			// get the next node from the stack
+			if (tStack.empty())
+				break;
+
+			entpX4 = extpX4;
+			entpY4 = extpY4;
+			entpZ4 = extpZ4;
+
+			minT4 = maxT4;
+			
+			PacketTraversalData *s  = tStack.top();
+			node = s->mNode;
+			
+			extpX4 = s->mExitPointX4;
+			extpY4 = s->mExitPointY4;
+			extpZ4 = s->mExitPointZ4;
+
+			maxT4 = s->mMaxT4;
+
+			mask4 = s->mMask4;
+
+			tStack.pop();
+			delete s;
+		}
+	}
+
+	return hits;
+
+/*
+	const int offs[4] = {(rp.dx[0] >= 0) ? 1 : 0,  (rp.dy[0] >= 0)? 1 : 0,  (rp.dz[0] >= 0)? 1 : 0, 0};
+
+	while (!node->IsLeaf())
+	{
+		PacketTraversalData *tData = tStack.top();
+		tStack.pop();
+
+		node = tData->node;
+		VspInterior *interior = static_cast<VspInterior *>(node);
+		tn4 = tData->tn4;
+		tf4 = tData->tf4;
+		mask = tData->mask4;
+
+		position = interior->GetPosition();
+		const __m128 position4 = _mm_load_ps(&pos);
+
+		const int axis = interior->GetAxis();
+		const __m128 d4 = _mm_mul_ps(_mm_sub_ps(splitPos, origin[axis]), termination[axis]);
+
+		VspNode* ln = offs[axis] ? interior->GetFront() : interior->GetBack();
+
+		if (!_mm_movemask_ps(_mm_and_ps(_mm_cmpgt_ps(d4, tn4), mask)))
+		{ 
+			node = ln; 
+			continue; 
+		}
+
+		node = offs[axis]^1 ? interior->GetFront() : interior->GetBack();// + (offs[aidx]^1);
+
+		if (_mm_movemask_ps( _mm_and_ps( _mm_cmplt_ps(d4, tf4), mask)))
+		{
+			const __m128 mask2 = _mm_cmpgt_ps(d4, tn4);
+			const __m128 mask3 = _mm_cmplt_ps(d4, tf4);
+
+
+			tData->tf4 = tf4 = _mm_or_ps(_mm_and_ps(mask3, d4), _mm_andnot_ps( mask3, tf4));
+			tData->node = (VspNode *)ln;
+			tData->mask4 = mask;
+			tData->tn4 = _mm_or_ps( _mm_and_ps( mask2, d4 ), _mm_andnot_ps( mask2, tn4 ) );
+			mask = _mm_cmplt_ps( tn4, tf4 );
+		}
+	}*/
+}
+#endif
 
 
@@ -3057,5 +3210,5 @@
 		else
 		{
-			//cout << "o";
+			//cout << "r";
 			// store object only for one ray
 			//lastVssRay->mOriginObject = ray->mTerminationObject;
@@ -3091,5 +3244,6 @@
 
 void VspTree::Initialise(const VssRayContainer &rays,
-						 AxisAlignedBox3 *forcedBoundingBox)
+						 AxisAlignedBox3 *forcedBoundingBox,
+						 const ObjectContainer &objects)
 {
 	ComputeBoundingBox(rays, forcedBoundingBox);
@@ -3100,4 +3254,7 @@
 	VspViewCell *viewCell = new VspViewCell();
     leaf->SetViewCell(viewCell);
+
+	viewCell->SetPvsCost((float)objects.size());
+	viewCell->SetEntriesInPvs(1);
 
 	// set view cell values
@@ -3276,5 +3433,5 @@
 	// simple render cost evaluation
 	if (-- leaf->mCounter == 0)
-		return BvHierarchy::EvalAbsCost(leaf->mObjects);
+		return (float)leaf->mObjects.size();
 	else
 		return 0.0f;
@@ -3341,5 +3498,5 @@
 		leaf->Mail();
 		leaf->mCounter = 1;
-		return BvHierarchy::EvalAbsCost(leaf->mObjects);
+		return (float)leaf->mObjects.size();
 	}
 	else
@@ -3418,5 +3575,5 @@
 	{
 		leaf->Mail();
-		return BvHierarchy::EvalAbsCost(leaf->mObjects);
+		return (float)leaf->mObjects.size();
 	}
 	else
@@ -3576,5 +3733,5 @@
 	{
 		leaf->Mail();
-		return BvHierarchy::EvalAbsCost(leaf->mObjects);
+		return (float)leaf->mObjects.size();
 	}
 	else
@@ -3655,74 +3812,4 @@
 
 	return pvs;
-}
-
-
-VspNode *VspTree::SubdivideAndCopy(SplitQueue &tQueue,
-								   SubdivisionCandidate *splitCandidate)
-{
-	// todo remove dynamic cast
-	VspSubdivisionCandidate *sc = static_cast<VspSubdivisionCandidate *>(splitCandidate);
-
-	VspTraversalData &tData = sc->mParentData;
-	VspNode *newNode = tData.mNode;
-	VspNode *oldNode = (VspNode *)splitCandidate->mEvaluationHack;
-
-	if (!oldNode->IsLeaf())
-	{	
-		///////////
-		//-- continue subdivision
-
-		VspTraversalData tFrontData;
-		VspTraversalData tBackData;
-		
-		VspInterior *oldInterior = static_cast<VspInterior *>(oldNode);
-
-		// create new interior node and two leaf node
-		const AxisAlignedPlane splitPlane = oldInterior->GetPlane();
-		sc->mSplitPlane = splitPlane;
-	
-		// evaluate the changes in render cost and pvs entries
-		EvalSubdivisionCandidate(*sc, false);
-
-		newNode = SubdivideNode(*sc, tFrontData, tBackData);
-	
-		//oldNode->mRenderCostDecr += sc->GetRenderCostDecrease();
-		//oldNode->mPvsEntriesIncr += sc->GetPvsEntriesIncr();
-
-		//oldNode->mRenderCostDecr = sc->GetRenderCostDecrease();
-		//oldNode->mPvsEntriesIncr = sc->GetPvsEntriesIncr();
-
-		/////////////
-		//-- evaluate new split candidates for global greedy cost heuristics
-
-		VspSubdivisionCandidate *frontCandidate = new VspSubdivisionCandidate(tFrontData);
-		VspSubdivisionCandidate *backCandidate = new VspSubdivisionCandidate(tBackData);
-
-		frontCandidate->SetPriority((float)-oldInterior->GetFront()->mTimeStamp);
-		backCandidate->SetPriority((float)-oldInterior->GetBack()->mTimeStamp);
-
-		frontCandidate->mEvaluationHack = oldInterior->GetFront();
-		backCandidate->mEvaluationHack = oldInterior->GetBack();
-
-		// cross reference
-		tFrontData.mNode->SetSubdivisionCandidate(frontCandidate); 
-		tBackData.mNode->SetSubdivisionCandidate(backCandidate);
-
-		tQueue.Push(frontCandidate);
-		tQueue.Push(backCandidate);
-
-		// note: leaf is not destroyed because it is needed to collect 
-		// dirty candidates in hierarchy manager
-	}
-
-	if (newNode->IsLeaf()) // subdivision terminated
-	{
-		// detach subdivision candidate: this leaf is no candidate for splitting anymore
-		tData.mNode->SetSubdivisionCandidate(NULL); 
-		// detach node so it won't get deleted
-		tData.mNode = NULL;
-	}
-
-	return newNode;
 }
 
@@ -3857,129 +3944,6 @@
 }
 
-#if 0
-void VspTree::TraverseRayPacket(RayBundle &rays);
-{
-	float splitPos [3];
-	float dist[3];
-
-	const int allValid = 1xf;
-	int mask = all_valid;
-
-	int comparisonResult = 0;
-
-	while (!node->IsLeaf())
-	{
-		comparisonResult = 0;
-
-		for (int i = 0; i < 4; ++ i)
-		{
-			splitPos[i] = node->splitPos;
-			dist[i] = (splitpos[i]  rp.origin[i][axis]) / (rp.dir[i][axis]);
-
-			comparisonresult |= ((dist[i] <= tnear[i]) << i);
-		}
-		
-		comparisonresult &= mask;
-
-		if (comparisonresult == allValid)
-		{ 
-			node = node->far;
-			continue
-		}
-
-		comparisonresult = 0;
-
-		for (int i = 0; i < 4; ++ i){
-            
-			comparisonresult |= (dist[i] >= tfar[i]);
-		}
-        
-		comparisonresult &= mask;
-        
-		if (comparisonresult == allValid)
-		{
-			node = node->near;
-			continue;
-		}
-		
-		if (comparisonresult)	
-		{
-		
-			Push( node->far, dist[0...3], tfar[0...3] )
-		
-			node = node->near;
-
-			mask = 0;
-
-			for (int i = 0; i < 4; ++ i)
-			{
-				bool b = (tnear[i] < tfar[i]);
-				mask |= b;
-                
-				if (b)
-				{
-					tfar[i] = dist[i];
-				}
-
-			}
-
-		}
-}
-#endif
-
-
-
-void VspTree::TraverseRayPacket()//RayBundle &rays)
-{
-#ifdef USE_SSE
-	VspNode *node;
-
-	RayPacket rp;
-
-	__m128 mask;
-	__m128 tf4;
-	__m128 tn4;
-	//const int offs[4] = { (RP->dcell[0] >= 0)?1:0,  (RP->dcell[4] >= 0)?1:0,  (RP->dcell[8] >= 0)?1:0, 0 };
-	
-	const int offs[4] = { 0, 0, 0, 0 };
-
-	while (!node->IsLeaf())
-	{
-		VspInterior *interior = static_cast<VspInterior *>(node);
-
-		float pos = interior->GetPosition();
-		const __m128 spos = _mm_load_ps(&pos);
-		
-		const int aidx = interior->GetAxis();
-		const __m128 d4;// = _mm_mul_ps( _mm_sub_ps( spos, RP->oc4[aidx] ), RP->rdc4[aidx] );
-		
-		VspNode* ln = interior->GetBack();// + offs[aidx];
-		
-		if (!_mm_movemask_ps( _mm_and_ps( _mm_cmpgt_ps( d4, tn4 ), mask ) )) 
-		{ 
-			node = ln; 
-			continue; 
-		}
-		
-		node = interior->GetBack();// + (offs[aidx]^1);
-		
-		if (_mm_movemask_ps( _mm_and_ps( _mm_cmplt_ps( d4, tf4 ), mask ) ))
-		{
-			const __m128 mask2 = _mm_cmpgt_ps( d4, tn4 );
-			const __m128 mask3 = _mm_cmplt_ps( d4, tf4 );
-			
-			//m_Stack[stackptr].tf4 = tf4;
-
-			tf4 = _mm_or_ps( _mm_and_ps( mask3, d4 ), _mm_andnot_ps( mask3, tf4 ) );
-
-			//m_Stack[stackptr].node = (KdTreeNode*)ln;
-			//m_Stack[stackptr].mask = mask;
-			//m_Stack[stackptr++].tn4 = _mm_or_ps( _mm_and_ps( mask2, d4 ), _mm_andnot_ps( mask2, tn4 ) );
-			mask = _mm_cmplt_ps( tn4, tf4 );
-		}
-	}
-#endif
-
-}
-
-}
+
+
+
+}
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/KdTree.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/KdTree.h	(revision 2176)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/KdTree.h	(revision 2332)
@@ -422,8 +422,7 @@
 				);
 
-  int
-  CollectLeafPvs();
-
   bool ExportBinTree(const std::string &filename);
+
+  /// loads kd tree from disk. note: sorts objects by id
   bool LoadBinTree(const std::string &filename, ObjectContainer &object);
 
